<template>
  <div>
    <el-table
      v-loading.fullscreen.lock="loading"
      :data="tableData"
      border
      style="width: 100%">
      <!--      @row-click="getFileList">-->
      <el-table-column
        align="center"
        label="序号"
        type="index"
        width="50"
        :index="this.indexStart">
      </el-table-column>
      <el-table-column
        align="center"
        prop="type"
        label="档案类别"
        width="250">
      </el-table-column>
      <el-table-column
        align="center"
        prop="volumeNumber"
        label="全宗号"
        width="70">
      </el-table-column>
      <el-table-column
        align="center"
        prop="number"
        label="档号"
        width="180">
        <template slot-scope="scope">
          <el-button type="text" @click="getFileList(scope.row)">{{scope.row.number}}</el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        prop="year"
        label="年度"
        width="70">
      </el-table-column>
      <el-table-column
        align="center"
        prop="retentionPeriod"
        label="保管期限"
        width="60">
      </el-table-column>
      <el-table-column
        align="center"
        prop="institution"
        label="机构(问题)"
        width="70">
      </el-table-column>
      <el-table-column
        align="center"
        prop="responsiblePerson"
        label="责任者"
        width="130">
      </el-table-column>
      <el-table-column
        align="center"
        prop="title"
        label="正题名"
        width="330">
      </el-table-column>
      <el-table-column
        align="center"
        prop="startTimeStr"
        label="起时间"
        width="120">
      </el-table-column>
      <el-table-column
        align="center"
        prop="endTimeStr"
        label="止时间"
        width="120">
      </el-table-column>
      <el-table-column
        align="center"
        prop="pages"
        label="页数"
        width="60">
      </el-table-column>
      <el-table-column
        align="center"
        prop="files"
        label="件数"
        width="60">
      </el-table-column>
      <el-table-column
        align="center"
        prop="createTimeStr"
        label="归档时间"
        width="120">
      </el-table-column>
      <el-table-column
        align="center"
        prop="fileType"
        label="档案类别"
        width="100">
      </el-table-column>
      <el-table-column
        align="center"
        prop="secondaryCategory"
        label="二级类目"
        width="250">
      </el-table-column>
      <el-table-column
        align="center"
        prop="categoryType"
        label="类别代码"
        width="70">
      </el-table-column>
      <el-table-column
        align="center"
        prop="businessType"
        label="业务类别"
        width="200">
      </el-table-column>
      <el-table-column
        align="center"
        prop="fileNumber"
        label="案卷号"
        width="70">
      </el-table-column>
      <el-table-column align="center" fixed="right" label="操作" width="100">
        <template slot-scope="scope">
          <el-button type="primary" size="mini" plain @click="exportArchive(scope.row)">导出</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-button
      class="fileButton"
      type="primary"
      @click="exportArchiveList">
      导出案卷列表
    </el-button>
    <el-pagination
      class="pone"
      :page-size="pageSize"
      :page-sizes="[10, 30, 50, 100]"
      @size-change="handleSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
      :total="totals"
      :current-page.sync="pageNum"
      @current-change="current_change">
    </el-pagination>
  </div>
</template>
<script>
  import CryptoJS from 'crypto-js'
  import {baseUrl} from "../../utils/global"
  import axios from "axios"
  import Cookies from "js-cookie";

  export default {
    data() {
      return {
        tableData: [],
        loading: false,
        totals: 0,
        pageNum: 1,
        pageSize: 10,
        indexStart: 1,
      }
    },
    methods: {
      current_change(pageNum) {
        this.pageNum = pageNum;
        this.indexStart = (pageNum - 1) * this.pageSize + 1;
        const data = {
          pageNum: pageNum,
          pageSize: this.pageSize,
        };
        this.search(data);
      },
      search(data) {
        this.loading = true;
        this.$api.getlist.selectArchive(data)
          .then((response) => {
            if (response.code === 200) {
              this.tableData = response.data.content;
              this.totals = response.data.totalSize;
            }
          })
          .catch((response) => {
          });
        this.loading = false;
      },
      handleSizeChange(pageSize) {
        this.pageSize = pageSize;
        this.pageNum = 1;
        this.indexStart = 1;
        const data = {
          pageNum: 1,
          pageSize: pageSize,
        };
        this.search(data);
      },
      getFileList(row) {
        this.$router.push({
          name: "档案文件",
          params: {
            archiveObject: row
          }
        });
      },
      decrypt(word) {
        var key = CryptoJS.enc.Utf8.parse("KkweInfo23255625");
        var decrypt = CryptoJS.AES.decrypt(word, key, {mode: CryptoJS.mode.ECB, padding: CryptoJS.pad.Pkcs7});
        return CryptoJS.enc.Utf8.stringify(decrypt).toString();
      },
      decryptByDES(ciphertext) {
        var keyHex = CryptoJS.enc.Utf8.parse("KkweFace95271124");
        var decrypted = CryptoJS.DES.decrypt({
          ciphertext: CryptoJS.enc.Base64.parse(ciphertext)
        }, keyHex, {
          mode: CryptoJS.mode.ECB,
          padding: CryptoJS.pad.Pkcs7
        });
        return decrypted.toString(CryptoJS.enc.Utf8);
      },
      exportArchive(archive) {
        this.loading = true;
        axios.get(baseUrl + '/archive/getArchivePdf', {
          headers: {
            "token": Cookies.get("token")
          },
          params: {
            archiveId: archive.id
          },
          responseType: 'blob'      //告诉服务器我们需要的响应格式
        })
          .then(res => {
            let a = document.createElement("a");
            let blob = new Blob([res.data], {
              type: 'application/vnd.ms-excel'      //将会被放入到blob中的数组内容的MIME类型
            });
            a.href = URL.createObjectURL(blob);  //生成一个url
            a.download = archive.title + ".rar";
            a.click();
            this.loading = false;
          })
          .catch(err => {
            console.log(err);
            this.loading = false;
          });
      },
      exportArchiveList() {
        this.loading = true;
        axios.get(baseUrl + '/exportExcel/archiveList', {
          headers: {
            "token": Cookies.get("token")
          },
          responseType: 'blob'      //告诉服务器我们需要的响应格式
        })
          .then(res => {
            let a = document.createElement("a");
            let blob = new Blob([res.data], {
              type: 'application/vnd.ms-excel'      //将会被放入到blob中的数组内容的MIME类型
            });
            a.href = URL.createObjectURL(blob);  //生成一个url
            a.download = "归档案卷列表" + Date.now() + ".xlsx";
            a.click();
            this.loading = false;
          })
          .catch(err => {
            console.log(err);
            this.loading = false;
          });
      }
    },
    created() {
      this.loading = true;
      const data = {
        pageNum: 1,
        pageSize: this.pageSize
      };
      this.$api.getlist.selectArchive(data)
        .then((response) => {
          if (response.code === 200) {
            this.tableData = response.data.content;
            this.totals = response.data.totalSize;
          }
        })
        .catch((response) => {
        });
      this.loading = false;
    }
  }
</script>
<style scoped>
  .pone {
    margin-top: 20px;
    margin-bottom: 20px;
  }

  .fileButton {
    width: 10%;
    margin-top: 10px;
  }

  .wrap {
    overflow: hidden;
    position: relative;
  }

  .masks {
    width: 100%;
    height: 100%;
    position: absolute;
    left: 0;
    top: 0;
    z-index: 200
  }

  .form {
    float: left;
    width: 45%;
    margin-left: 20px
  }

  .imgcon {
    margin: 0 auto;
    box-shadow: 0 0 15px lightgray;
    overflow: hidden;
    margin-bottom: 40px
  }

  .block {
    width: 23%
  }

  .block {
    float: left;
    height: 100%;
    margin-right: 20px
  }

  .imtil {
    padding: 0 0 20px 0
  }
</style>
